// gjdboard.cpp : AvP[ṼGg |Cg`܂B
//

#include "stdafx.h"
#include "gjdboard.h"

// O[oϐ:
HINSTANCE hInst;								// ݂̃C^[tFCX

// ptH[}XJE^擾pϐ
PDH_HQUERY   hPDHQuery = NULL;
PDH_HCOUNTER hPDHCounterCPU = NULL;
//HICON hIconBig, hIconSmall;

// ̃R[h W[Ɋ܂܂֐̐錾]܂:
INT_PTR CALLBACK ProcDashBoard(HWND, UINT, WPARAM, LPARAM);

int APIENTRY _tWinMain(HINSTANCE hInstance, HINSTANCE, LPTSTR,int)
{
	hInst = hInstance;
	//hIconBig = (HICON)LoadImage(hInst, (LPCTSTR)IDI_GJDBOARD, IMAGE_ICON, 16, 16, LR_SHARED);
	//hIconSmall = (HICON)LoadImage(hInst, (LPCTSTR)IDI_GJDBOARD, IMAGE_ICON, 32, 32, LR_SHARED);

	DialogBox(hInst, (LPCTSTR)IDD_DASHBOARD, NULL, (DLGPROC)ProcDashBoard);

	if (hPDHQuery) {
		PdhCloseQuery(hPDHQuery);
	}

	return 0;
}

// o[W{bNX̃bZ[W nh[łB
INT_PTR CALLBACK ProcDashBoard(HWND hDlg, UINT message, WPARAM wParam, LPARAM)
{
	static HRSRC hRsrc;
	static HANDLE hRes;
	static void *lpWavData;

	switch (message)
	{
		case WM_INITDIALOG:
			// EBhȄʒu̐ݒi[Acʒu͒j
			{
				RECT war;
				SystemParametersInfo(SPI_GETWORKAREA, 0, &war, 0);

				SetWindowPos(hDlg, HWND_TOPMOST, war.left, war.bottom/2, 0, 0, SWP_NOACTIVATE | SWP_NOSIZE | SWP_SHOWWINDOW);

				//SendMessage(hDlg, WM_SETICON, (WPARAM)ICON_BIG, (LPARAM)hIconBig);
				//SendMessage(hDlg, WM_SETICON, (WPARAM)ICON_SMALL, (LPARAM)hIconSmall);
			}

			if (hPDHQuery == NULL) {
				// CPUp/ǂݏô߂̏
				if (PdhOpenQuery(NULL, 0, &hPDHQuery) == ERROR_SUCCESS) {
					PdhAddCounter(hPDHQuery, _T("\\Processor(_Total)\\% Processor Time"), 0, &hPDHCounterCPU);
				}
				SetDlgItemText(hDlg, IDC_INFO_CPUUSAGE, _T("擾..."));
				SetDlgItemText(hDlg, IDC_INFO_AMEMORY, _T("擾..."));
				SetDlgItemText(hDlg, IDC_INFO_PMEMORY, _T("擾..."));
				SetDlgItemText(hDlg, IDC_INFO_VMEMORY, _T("擾..."));
				SetDlgItemText(hDlg, IDC_INFO_BATTERY, _T("擾..."));
			}

			// \[X̃[h
			// IDR_WAVE2 c 321̊mōĐ钿
			// IDR_WAVE1 c ʏ̊mōĐ_bV
			hRsrc = FindResource(hInst, GetTickCount()%32 == 0 ? (LPCTSTR)IDR_WAVE2 : (LPCTSTR)IDR_WAVE1, (LPCTSTR)_T("WAVE"));
			hRes = LoadResource(hInst, hRsrc);
			lpWavData = LockResource(hRes);

			// _bV{[hXV^C}̐ݒ
			SetTimer(hDlg, 1616, 1000, NULL);
			return (INT_PTR)TRUE;

		case WM_TIMER:
			if ((int)wParam == 1616) {
				// _bV{[h̍XVi1ڂ͏擾JnA2ڈȍ~͍XVj
				
				if (hPDHQuery != NULL) {
					PDH_FMT_COUNTERVALUE fntValueCPU;
					static DWORD dwLastQuery;
					DWORD dwNowTime = GetTickCount();
					TCHAR tbuf[80];

					if (dwLastQuery < dwNowTime-1000) {
						dwLastQuery = dwNowTime;
						PdhCollectQueryData(hPDHQuery);
						PdhGetFormattedCounterValue(hPDHCounterCPU, PDH_FMT_LONG, NULL, &fntValueCPU);

						MEMORYSTATUSEX mem;
						mem.dwLength = sizeof(MEMORYSTATUSEX);
						GlobalMemoryStatusEx(&mem);

						SYSTEM_POWER_STATUS sps;
						if (!GetSystemPowerStatus(&sps)) {
							sps.BatteryLifePercent = BATTERY_PERCENTAGE_UNKNOWN;
						}

						// IDC_INFO_CPUUSAGE
						_stprintf_s(tbuf, _countof(tbuf), _T("%d %%"), fntValueCPU.longValue);
						SetDlgItemText(hDlg, IDC_INFO_CPUUSAGE, tbuf);

						// IDC_INFO_AMEMORY
						_stprintf_s(tbuf, _countof(tbuf), _T("%4I64u / %4I64u MB"), mem.ullAvailPhys/1024/1024, mem.ullTotalPhys/1024/1024);
						SetDlgItemText(hDlg, IDC_INFO_AMEMORY, tbuf);

						// IDC_INFO_PMEMORY
						_stprintf_s(tbuf, _countof(tbuf), _T("%4I64u / %4I64u MB"), mem.ullAvailPageFile/1024/1024, mem.ullTotalPageFile/1024/1024);
						SetDlgItemText(hDlg, IDC_INFO_PMEMORY, tbuf);

						// IDC_INFO_VMEMORY
						_stprintf_s(tbuf, _countof(tbuf), _T("%4I64u / %4I64u MB"), mem.ullAvailVirtual/1024/1024, mem.ullTotalVirtual/1024/1024);
						SetDlgItemText(hDlg, IDC_INFO_VMEMORY, tbuf);

						// IDC_INFO_BATTERY
						if (sps.BatteryLifePercent == BATTERY_PERCENTAGE_UNKNOWN) {
							SetDlgItemText(hDlg, IDC_INFO_BATTERY, _T("---"));
						}
						else {
							_stprintf_s(tbuf, _countof(tbuf), _T("%d %%"), sps.BatteryLifePercent);
							SetDlgItemText(hDlg, IDC_INFO_BATTERY, tbuf);
						}
					}
				}

				static int sec = 0;
				++sec;
				if (sec < 5) {
					SetDlgItemText(hDlg, IDC_OSUNAOSUNAYO, _T(""));
				}
				else if (5 <= sec && sec < 10) {
					SetDlgItemText(hDlg, IDC_OSUNAOSUNAYO, _T(""));
					SetDlgItemText(hDlg, IDOK, sec % 2 == 0 ? _T("&b") : _T("&B"));
				}
				else if (10 <= sec && sec < 15) {
					SetDlgItemText(hDlg, IDC_OSUNAOSUNAYO, _T("!"));
					SetDlgItemText(hDlg, IDOK, sec % 2 == 0 ? _T("&b") : _T("&B"));
				}
				else if (15 <= sec && sec < 20) {
					SetDlgItemText(hDlg, IDC_OSUNAOSUNAYO, _T(""));
					SetDlgItemText(hDlg, IDOK, sec % 2 == 0 ? _T("&b") : _T("&B"));
				}
				else if (20 <= sec && sec < 25) {
					SetDlgItemText(hDlg, IDC_OSUNAOSUNAYO, _T("Ȃ"));
					SetDlgItemText(hDlg, IDOK, sec % 2 == 0 ? _T("&b") : _T("&B"));
				}
				else if (25 <= sec && sec < 30) {
					SetDlgItemText(hDlg, IDC_OSUNAOSUNAYO, _T(""));
					SetDlgItemText(hDlg, IDOK, sec % 2 == 0 ? _T("&b") : _T("&B"));
				}
				else if (30 <= sec && sec < 35) {
					SetDlgItemText(hDlg, IDC_OSUNAOSUNAYO, _T("΂ɁA"));
					SetDlgItemText(hDlg, IDOK, sec % 2 == 0 ? _T("&b") : _T("&B"));
				}
				else if (35 <= sec && sec < 40) {
					SetDlgItemText(hDlg, IDC_OSUNAOSUNAYO, _T(""));
					SetDlgItemText(hDlg, IDOK, sec % 2 == 0 ? _T("&b") : _T("&B"));
				}
				else if (40 <= sec && sec < 45) {
					SetDlgItemText(hDlg, IDC_OSUNAOSUNAYO, _T("Ȃ"));
					SetDlgItemText(hDlg, IDOK, sec % 2 == 0 ? _T("&b") : _T("&B"));
				}
				else if (45 <= sec && sec < 50) {
					SetDlgItemText(hDlg, IDC_OSUNAOSUNAYO, _T(""));
					SetDlgItemText(hDlg, IDOK, sec % 2 == 0 ? _T("&b") : _T("&B"));
				}
				else {
					sec = 0;
					SetDlgItemText(hDlg, IDOK, _T("&B"));
				}
			}
			else if ((int)wParam == 3232) {
				static int dash = 32;
				static RECT war;
				RECT rect;

				if (dash == 32) {
					SystemParametersInfo(SPI_GETWORKAREA, 0, &war, 0);
				}

				GetWindowRect(hDlg, &rect);
				dash += 2;

				SetWindowPos(hDlg, HWND_TOPMOST, rect.left + dash, rect.top, 0, 0, SWP_NOACTIVATE | SWP_NOSIZE | SWP_SHOWWINDOW);

				if (rect.left > war.right) {
					SetWindowPos(hDlg, HWND_TOPMOST, war.left, war.bottom/2, 0, 0, SWP_NOSIZE | SWP_HIDEWINDOW);

					KillTimer(hDlg, 3232);
					MessageBox(hDlg, _T("B_bV܂B"), _T("^_bV{[h"), MB_OK | MB_ICONINFORMATION);
					EndDialog(hDlg, 0);
				}
			}
			return 0;

		case WM_DESTROY:
			// EBhE̔j
			KillTimer(hDlg, 1616);
			KillTimer(hDlg, 3232);
			return 0;

		case WM_COMMAND:
			switch (wParam) {
				case IDCANCEL:
					// ~{^̉
					if (MessageBox(hDlg, _T("IĂ낵ł?"), _T("^_bV{[h"), MB_ICONQUESTION | MB_OKCANCEL) == IDOK) {
						EndDialog(hDlg, 0);
					}
					break;

				case IDHELP:
					// ?{^̉(o[W)
					MessageBox(hDlg, _T("^_bV{[h ver.1.01\r\nCopyright(C) 2019 INASOFT\r\nhttps://www.inasoft.org/\r\n\r\n{\tg̓W[N\tgłBW[N̂킩݂̂p܂悤A肢܂B"), _T("o[W"), MB_OK | MB_ICONINFORMATION);
					break;

				case IDOK:
					// B_bV{^̉
					PlaySound((LPCTSTR)lpWavData, NULL, SND_ASYNC | SND_MEMORY);
					SetTimer(hDlg, 3232, 16, NULL);
					break;
			}
			break;
	}
	return (INT_PTR)FALSE;
}
